﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using METAbolt;
using METAxCommon;
using SLNetworkComm;
using System.Timers;
using OpenMetaverse;


namespace CBAI
{
    public class CBAI
    {
        private METAboltInstance instance;
        private GridClient client;
        private SLNetCom netcom;

        private Timer timer;
        private static int cnt = 0; // used for flood protection

        public CBAI(METAboltInstance instance)
        {
            // Intialize private members
            this.instance = instance;
            netcom = this.instance.Netcom;
            client = this.instance.Client;

            // Register events
            netcom.ChatReceived += new EventHandler<ChatEventArgs>(OnChatReceived);
            client.Objects.AvatarUpdate += new EventHandler<AvatarUpdateEventArgs>(OnNewAvatar);

            //timer used for flood protection
            timer = new Timer(4000);
            timer.Elapsed += new ElapsedEventHandler(OnTimer);
            timer.Start();
        }

        public void OnChatReceived(object sender, ChatEventArgs e)
        {
            if (instance.IsAvatarMuted(e.OwnerID)) return;
            if (string.IsNullOrEmpty(e.Message)) return;

            String botName = instance.Client.Self.Name;

            if (e.FromName != botName)
            {
                if (e.Message.ToLower().Contains("stop"))
                {
                    instance.State.Follow(String.Empty);
                    instance.State.LookAt(false, UUID.Zero); // first disable the 'lookat' option from settings which behaves strangely showing crosshair on all avatars. If you have many bots in a sim then you'll see white overlaped unreadable text on your head
                }
                else if (e.Message.ToLower().Contains("follow"))
                {
                    instance.State.Follow(e.FromName);
                }
                else if (e.Message.ToLower().Contains("look at me")) // must disable to lookat option in preferences
                {
                    instance.State.LookAt(true, e.OwnerID);
                }
                else if (e.Message.ToLower().Contains("enumerate"))
                {

                }
                else
                {
                    Say("I am " + botName);
                }

                // TODO: touch, sit, enumerate present avatars, identify and salute new avatars
            }
        }

        private void OnNewAvatar(object sender, AvatarUpdateEventArgs e)
        {
            Say("New avatar " + e.Avatar.Name);
            // I should filter the messages, not all are "new avatar" events.
        }


        public void OnTimer(object sender, ElapsedEventArgs e)
        {
            cnt = 0; // reset flood protection
        }

        public void Say(string txt)
        {
            if (!string.IsNullOrEmpty(txt) && cnt < 4)
            {
                netcom.ChatOut(txt, ChatType.Normal, 0);
                cnt++;
            }
        }
    }
}
